;      224 (஢) 

;	뢮 ⢫  2 ப, 祬
;	  ப -   (뢮 ६)
; 	 ப - 騩 ⥪  䠩 <texts.h> 
;
; ᯮ㥬  = 4 
;    24200 NRB/R (㯫     )

; ࠡ⠫ 誠ॢ  /// oleg.omsk@usa.net

		LIST		P=16F84

;  䠩 <my_mac.inc> 祭  ࠢ , ஢ ᪨
; 㪢    ⠭ 䠩  Microchip  PIC16F84

#include <my_mac.inc>


		__config	h'3FF9'

place equ	.4 ; (1...23)  砫 뢮  孥 ப
 
#define _int	flag,0	; 䫠 'pp뢠 p諮'
#define _bank	flag,1	; 䫠 '࠭ । 뢠'


LCD_DATA         EQU     PORTB
LCD_DATA_TRIS    EQU     TRISB-0x80
;
LCD_CNTL         EQU     PORTB
LCD_CNTL_TRIS    EQU     TRISB-0x80
;
; LCD Display Commands and Control Signal names.
;
E       EQU     1       ; LCD Enable control line
R_W     EQU     2       ; LCD Read/Write control line
RS      EQU     3       ; LCD Register Select control line

; ++++++++++++++++++++++++++++ 祭   +++++++++++++++++
; 4...7 	- 
; 1		- 
; 2		- R/W
; 3		- RS

	CBLOCK .12

rab1	; bcd
rab2	; bcd, delay20, delay5
rab3	; bcd, delay1 
rab4	; 
rab5	;  뢮 ப  LCD
Temp	; (LCD)-䫠 busy  ⥪騩  DDRAM
Char	; (LCD)-c࠭  뢮 ᨬ  
t50ms 	; 稪 p  ᮢ 
t1sec
t1min	
t1hour

push_W	;  祩   W  STATUS p INT...
push_S	
flag
	ENDC

 org     0x00
		goto    START
 org     0x04
		goto	interrupt	

Table:
	addwf   PCL,f           ; Jump to character
	include "texts.h"
START 	
	call init_reg
	call    LCD_Init        ; Set up the LCD Module
	movlw   CLR_DISP	; ...
	call    Send_Cmd
	movlw   b'00001111'	; Display on, cursor on, blink on
	call    Send_Cmd
	movlw   b'00000110'	; Increment cursor (Entry_Set)
	call    Send_Cmd
	movlw	LINE2+.23	; 㤥 뢮   ப 1
	call 	Send_Cmd

long
	movlw   0               ; Table address (start of message)
	call string
	goto long
 
; ********************************************************
; 뢮 ப ᨬ  ᯫ  Table (ᬥ饭  W)
; ********************************************************

string				
	movwf   rab5       ; rab5 holds start of message address
	call    Table
	andlw   0FFh            
	btfsc   STATUS,Z   ; Check if at end of message (zero returned at end)
	return		   ; goto    out             
	call    Send_Char  ; Display character

	call	delay100   ; প  뢮 - । ᪮ ᤢ

;  ᯫ  ⮣, ⮡  " "
	movlw b'00011000'
	call scmd

; 砥 ⥪騩     ᪠, ⮡ ⥪騩   
;   ப
	call Wait_Busy		; ⥭ ⥪饣 
	cmp Temp,0	;      1- ப?
	sz	
	goto prod
	movlw LINE2	; ⠭   2- ப
	call scmd

prod

;  ⮩ প, 祬- 砩 ᤢ  ப
	call d100mks	; ??? without it -> error...       ******???******
			; 稭 ⠫ ᭮...      ******???******

; 室 ⠭ ⥪騩  DDRAM 
;   ⮣, ⮡  ६ ᤢ  2 ப 室
;   ப  ࣠ ⠬  ⥪

 	call str1
	movf    rab5,w     ; Point to next character
	addlw   1
	goto    string

;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
;                   
;+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
str1			  	
	call Wait_Busy	   ; ⥭ ⥪饣   	
	movff Temp,rab4	   ;  ࠭ 
	cmp Temp,40+.24-place    ; - to right
	sc		
	goto mgr	   ; Temp < ࠭
; Temp > ࠭
	movlw 0x40+.24-place	   ; 䨪஢  뢮
	subwf Temp,w	   ;   2- ப - ᬥ (   1-)
	goto combm
mgr
	movlw 0x40	   ; 䨪஢  뢮
	subwf Temp,w	   ;   2- ப - ᬥ (   1-)
	addlw .16+place	   ; from 0 to middle of display
	goto combm
combm
	iorlw b'10000000'  ; for DD RAM Adress Set
	call	Send_Cmd
; ନ㥬  ⥪  1- ப
	movlw '	'	;  易⥫쭮 ஡  ࠭
	call sch_b

	movlw 'T'
	call sch_b
	movlw 'i'
	call sch_b
	movlw 'm'
	call sch_b
	movlw 'e'
	call sch_b
	movlw ' '
	call sch_b
	movlw 'i'
	call sch_b
	movlw 's'
	call sch_b
	movlw ' '
	call sch_b

 call time			; 뢮 ६  LCD

	movf rab4,w		; ⠭    2 ப
	iorlw b'10000000'	; for DD RAM Adress Set
	call	Send_Cmd
	return
;
sch_b			; 뢮 ᨬ  ஢મ 室  2 ப
	call schar
	call Wait_Busy		;   ?
	cmp Temp,0x40	;      2- ப?
	sz	
	return
	movlw LINE1	; ⠭   2- ப
	call scmd
	return

; ********************************************************************
;              뢮   ப ६   ᪠
; ********************************************************************

time
	movf t1hour,w	;  ᫮ ᮢ
	call bcd	; ८ࠧ㥬  . 
	movf rab2,w
	addlw 0x30	;  
	call sch_b	; , ᯮ r1...r3

	movf t1hour,w
	call bcd
	addlw 0x30	;  
	call sch_b	; use r1...r3

	movlw '-'
	call sch_b	; use r1...r3

	movf t1min,w
	call bcd
	movf rab2,w
	addlw 0x30	;  
	call sch_b	; use r1...r3

	movf t1min,w
	call bcd
	addlw 0x30	;  
	call sch_b	; use r1...r3

	movlw '-'
	call sch_b	; use r1...r3

	movf t1sec,w
	call bcd
	movf rab2,w
	addlw 0x30	;  
	call sch_b	; use r1...r3

	movf t1sec,w
	call bcd
	addlw 0x30	;  
	call sch_b	; use r1...r3
	return

;
;*******************************************************************
;* The LCD Module Subroutines                                      *
;*******************************************************************
;
;*******************************************************************
;*SendChar - Sends character to LCD                                *
;*This routine splits the character into the upper and lower       * 
;*nibbles and sends them to the LCD, upper nibble first.           *
;*******************************************************************
;
schar
Send_Char
	movwf   Char            ; Character to be sent is in W
	call    Wait_Busy       ; Wait for LCD to be ready
	movlw   0x0f
	andwf   LCD_DATA,F      ; Clear the upper nibble
	movf    Char,w          
	andlw   0xF0            ; Get upper nibble
	iorwf   LCD_DATA,F      ; Send data to LCD
	bcf     LCD_CNTL, R_W   ; Set LCD to write
	bsf     LCD_CNTL, RS    ; Set LCD to data mode
	bsf     LCD_CNTL, E     ; toggle E for LCD
	bcf     LCD_CNTL, E
	movlw   0x0f
	andwf   LCD_DATA,F      ; Clear the upper nibble
	swapf   Char,W
	andlw   0xF0            ; Get lower nibble
	iorwf   LCD_DATA,F      ; Send data to LCD
	bsf     LCD_CNTL, E     ; toggle E for LCD
	bcf     LCD_CNTL, E
	return

;*******************************************************************
;* Send_Cmd - Sends command to LCD                                 *
;* This routine splits the command into the upper and lower        * 
;* nibbles and sends them to the LCD, upper nibble first.          *
;*******************************************************************
scmd
Send_Cmd
	movwf   Char            ; Character to be sent is in W
	call    Wait_Busy       ; Wait for LCD to be ready
	movlw   0x0f
	andwf   LCD_DATA,F      ; Clear the upper nibble
	movf    Char,w          
	andlw   0xF0            ; Get upper nibble
	iorwf   LCD_DATA,F      ; Send data to LCD
	bcf     LCD_CNTL,R_W    ; Set LCD to write
	bcf     LCD_CNTL,RS     ; Set LCD to command mode
	bsf     LCD_CNTL,E      ; toggle E for LCD
	bcf     LCD_CNTL,E
	movlw   0x0f
	andwf   LCD_DATA,F      ; Clear the upper nibble
	swapf   Char,W
	andlw   0xF0            ; Get lower nibble
	iorwf   LCD_DATA,F      ; Send data to LCD
	bsf     LCD_CNTL,E      ; toggle E for LCD
	bcf     LCD_CNTL,E
	return
;
;*******************************************************************
;* This routine checks the busy flag, returns when not busy        *
;*  Affects:                                                       *
;*      Temp - Returned with busy/address                          *
;*******************************************************************
;   ਣ 뫠 訡! - ࠢ
Wait_Busy
	bsf     STATUS, RP0     ; Select Register page 1
	movlw   0xf0            ; Set port to input
	iorwf   LCD_DATA_TRIS,W ; Only set upper half of port
	movwf   LCD_DATA_TRIS
	bcf     STATUS, RP0     ; Select Register page 0
	bcf     LCD_CNTL, RS    ; Set LCD for Command mode
	bsf     LCD_CNTL, R_W   ; Setup to read busy flag

	bsf     LCD_CNTL, E     ; Set E high
	movf    LCD_DATA, W     ; Read upper nibble busy flag, DDRam address
	bcf     LCD_CNTL, E     ; Set E low

	andlw   0xF0            ; Mask out lower nibble
	movwf   Temp

	bsf     LCD_CNTL, E     ; Toggle E to get lower nibble
	swapf   LCD_DATA, w     ; Read lower nibble busy flag, DDRam address
	bcf     LCD_CNTL, E


	andlw   0x0F            ; Mask out upper nibble
	iorwf   Temp,f          ; Combine nibbles, RES in Temp !!!!!!!!!!!!!!!
	btfsc   Temp, 7         ; Check busy flag, high = busy
	goto    Wait_Busy       ; If busy, check again
	bcf     LCD_CNTL, R_W        
	bsf     STATUS, RP0     ; Select Register page 1
	movlw   0x0F
	andwf   LCD_DATA_TRIS,W
	movwf   LCD_DATA_TRIS   ; Set Port for output
	bcf     STATUS, RP0     ; Select Register page 0
	return
;
del10mks
	goto $+1
	goto $+1
	goto $+1
	goto $+1
	return
;
; Initilize the LCD Display Module
;
LCD_Init:

	bcf     LCD_CNTL, E     ; Clear all controll lines
	bcf     LCD_CNTL, RS
	bcf     LCD_CNTL, R_W

	call    delay20		; Wait for 15ms for LCD to get powered up

	movlw   0x0f
	andwf   LCD_DATA,F      ; Clear the upper nibble
	movlw   0x030           ; Command for 4-bit interface high nibble
	iorwf   LCD_DATA,F      ; Send data to LCD      

	bsf     STATUS, RP0     ; Select Register page 1
	movlw   0x0F
	andwf   LCD_DATA_TRIS,W
	movwf   LCD_DATA_TRIS   ; Set Port for output
	BCF     STATUS, RP0     ; Select Register page 0

	bsf     LCD_CNTL, E     ; Clock the initalize command to LCD module
	bcf     LCD_CNTL, E

	call    delay5		; Delay for at least 4.1ms before continuing

	bsf     LCD_CNTL, E     ; Clock the initalize command to LCD module
	bcf     LCD_CNTL, E
	
	 
	call    d100mks        ; delay for at least 100usec before continuing

	bsf     LCD_CNTL, E     ; Clock the initalize command to LCD module
	bcf     LCD_CNTL, E

	call    Wait_Busy       ; From here on, the Busy Bit will be valid.

	movlw   0x0f
	andwf   LCD_DATA,F      ; Clear the upper nibble
	movlw   0x020           ; Command for 4-bit interface high nibble (Really an 8bit command but
				;   lower 4 bits are don't care at this point)
	iorwf   LCD_DATA,F      ; Send data to LCD      

	bsf     LCD_CNTL, E     ; Clock the initalize command to LCD module
	bcf     LCD_CNTL, E

	movlw   FUNCTION_SET    ; Send the function set command 4-bit I/F, Font, Number of lines
	call    Send_Cmd        ; Can now use the Send_Cmd routine since Busy Bit Valid and in 4bit mode.
; LCD Module is now initalized
	return



; --------------------------------------------------------------------
; ணࠬ থ
; --------------------------------------------------------------------

delay100	call delay20		; প 100 
delay80		call delay20
delay60		call delay20
delay40		call delay20

delay20		call delay5		; প 20 
delay15		call delay5
delay10		call delay5

delay5	movlw d'5'
	movwf rab2		; N x 1 ms
delay1	mvi rab3,.249
d1m	nop
	decfsz rab3,f ;	4 x 250 = 1 ms
	goto d1m
	decfsz rab2,f
	goto delay1
	return

d100mks mvi rab3,.25
dll	nop		; 4 x 25 = 100 mkc
	decfsz rab3,f
	goto dll
	return

;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
init_reg
	bsf STATUS,RP0	  	; ࠭ 1
	movlw b'10010111' 	;   256,  rb-,  r  + 
	movwf OPTION_REG	;   . , ⥫  RTCC
        movlw b'00000000' 	; p 7...0 - 뢮 
	movwf PORTB
	movlw	b'11111000' 	; A4,A3 - , A2,A1,A0 - 뢮
	movwf PORTA
        bcf STATUS,RP0	  	; ࠭ 0

	 		;    p p
settr	
	clrf t1hour	;    ﬨ 00-00-00
	clrf t1min
	clrf t1sec
	clrf t50ms
	clrf flag
	clrf PORTA
	clrf PORTB
	movlw b'10100000' 	; pp襭   ⠩p pp뢠
	movwf INTCON
	return

;====   interrupt program    ====
;==== p稪 pp뢠  ====
;
;  ४ ६

interrupt
	bcf INTCON,T0IF 	; ⪠ 䫠 pp뢠 !p!
	btfss STATUS,RP0	;  ࠭ 뫠 । 뢠?
	goto bank0
	bcf STATUS,RP0  ;  ࠡ⪨ 뢠 -  0- ࠭
	bsf _bank	; ,  뫠 ࠭ 1
	goto c_pr
bank0	bcf _bank	; 뢠 䫠 (㤥 ஢ઠ  室)	
c_pr	movwf push_W 	; p "W"
	swapf push_W,f
	swapf STATUS,w
	movwf push_S ; p 䫠 STATUS ( ࠤ)
	movlw	d'61'; 樥  256-61=195 (256=49920)
	movwf	TMR0 ;  p 4 
	incf t50ms,f
	cmp t50ms,d'20'	; 20 ࠧ  50  = 1 ᥪ㭤
	sz
	goto ret_pr
	clrf t50ms	; ⠫ ᥪ㭤
	incf t1sec,f
	cmp t1sec,d'60' ;  諠?
	sz
	goto ret_pr
	clrf t1sec
	mvi t50ms,d'254';   ""  
	incf t1min,f
	cmp t1min,d'60' ;  襫?
	sz
	goto ret_pr
	clrf t1min
; ⥫쭠 ४    ( - 㡨ࠥ ⠢)
; ..     - ।
	mvi t1sec,1	;  ।  1 ᥪ㭤 ...
	mvi t50ms,d'3'	; ... ।  
	incf t1hour,f
	cmp t1hour,d'24'	; ⪨ 諨?
	sz
	goto ret_pr
	clrf t1hour
ret_pr	bsf _int	; ⠭ 䫠 "뫮 pp뢠"
	swapf push_S,w  ; ⠭ STATUS
	movwf STATUS	;  ࠭ ࠤ 뫨 ⠪ 
	swapf push_W,w	; ⠭ W
	btfsc _bank	; ஢塞,  ࠭ 뫠 । 뢠
	bsf STATUS,RP0
	retfie


;*********************************************************************
;              8 Bit binary ---> 3  BCD Number.
;*********************************************************************
; ८ࠧ㥬 W   
;        室 
; rab1 - ⭨, rab2 - ⪨, rab3 - , W -  ⮦
bcd
	clrf rab1	; ⭨
	clrf rab2	; ⪨
	movwf rab3	; 
ghun	movlw .100
	subwf rab3,w
	btfss STATUS,0	; CARRY
	goto gten
	movwf rab3	; ⮪  R2
	incf rab1,f	; ⭨
	goto ghun
gten	movlw .10
	subwf rab3,w
	btfss STATUS,0	; CARRY
	goto over
	movwf rab3	; ⮪  R2
	incf rab2,f	; ⪨
	goto gten
over	movf rab3,w	; 㡫㥬   R2  W
	return

	END







